const eps=1e-10;
const inf=1e100;
var 
  x,y,t,dx,dy:extended;
  i,n,k,w,h:integer;
  r1,r2:extended;
procedure solve(a,d:extended;z:integer;var t:extended);
var r:extended;
begin
  r:=z-a;
  if abs(d)<=eps then exit;
  r:=r/d;
  if r<eps then exit;
  if r>1+eps then exit;
  if t=inf then
    t:=r
  else if t>r then
      t:=r;
end;
begin
{  assign(input,'input.txt');
  reset(input);
  assign(output,'output.txt');
  rewrite(output);}
  read(n,k,w,h);
  x:=w/2;
  y:=h/2;
  r1:=0;
  r2:=0;
  for i:=1 to n do
  begin
    read(dx,dy);
    dx:=dx*k;
    dy:=dy*k;
    r1:=r1+sqrt(sqr(dx)+sqr(dy));
    while true do
    begin
      t:=inf;
      solve(x,dx,0,t);
      solve(x,dx,w,t);
      solve(y,dy,0,t);
      solve(y,dy,h,t);
      if t=inf then
        break;
      r2:=r2+sqrt(sqr(x+t*dx-w/2)+sqr(y+t*dy-h/2));
      dx:=dx*(1-t);
      dy:=dy*(1-t);
      x:=w/2;
      y:=h/2;
      if (abs(dx)<eps) and (abs(dy)<eps) then
        break;
    end;
    x:=x+dx;
    y:=y+dy;
  end;
  writeln(r1:1:3,' ',r2:1:3);
{  close(input);
  close(output);}
end.
